/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.protokollierung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.protokollierung.entity.ProtokollEintrag;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractProtokollEintragSearch {

  @Inject
  protected transient ProtokollEintragExtendedDAO dao;

  public AbstractProtokollEintragSearch() {
    super();
  }

  public List<ProtokollEintrag> getSearchResult(ProtokollEintragSearchParameters searchParameters, EagerLoadingCollector<ProtokollEintrag> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<ProtokollEintrag> querySearchResult(ProtokollEintragSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
